define('dummy/initializers/reopen-view', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  exports['default'] = {
    name: "reopen-view",
    initialize: function () {
      Ember['default'].View.reopen({
        transitionSpeed: 500,

        willTransitionIn: Ember['default'].K,
        transitionIn: Ember['default'].K,
        didTransitionIn: Ember['default'].K,

        willTransitionOut: Ember['default'].K,
        transitionOut: Ember['default'].K,
        didTransitionOut: Ember['default'].K,

        isTransitioningIn: false,
        isTransitioningOut: false,

        hasTransitionedIn: false,
        hasTransitionedOut: true,

        toggle: function () {
          return this.get("isActive") ? this.leave() : this.enter();
        },

        enter: function () {
          var v = this;
          if (!this.get("isDestroyed") && this.get("hasTransitionedOut")) {
            Ember['default'].run.scheduleOnce("afterRender", v, function () {
              Ember['default'].run.schedule("sync", v, function () {
                v.willTransitionIn();
                v.set("isTransitioningIn", true);
              });

              Ember['default'].run.next(v, v.transitionIn, function () {
                v.set("isTransitioningIn", false);
                v.set("hasTransitionedIn", true);
                v.set("hasTransitionedOut", false);

                Ember['default'].run.later(v, v.didTransitionIn, v.get("transitionSpeed") - 1);
              });
            });
          }
        },

        leave: function () {
          var v = this;
          if (!this.get("isDestroyed") && this.get("hasTransitionedIn")) {
            Ember['default'].run.scheduleOnce("afterRender", v, function () {
              Ember['default'].run.schedule("sync", v, function () {
                v.willTransitionOut();
                v.set("isTransitioningOut", true);
              });

              Ember['default'].run.next(v, v.transitionOut, function () {
                v.set("isTransitioningOut", false);
                v.set("hasTransitionedOut", true);
                v.set("hasTransitionedIn", false);

                Ember['default'].run.later(v, v.didTransitionOut, v.get("transitionSpeed") - 1);
              });
            });
          }
        }
      });
    }
  };

});