define('ember-foundation-apps/components/zf-action-sheet', ['exports', 'ember', 'ember-foundation-apps/mixins/zf-animation'], function (exports, Ember, ZfAnimationMixin) {

  'use strict';

  var ZfActionSheetComponent = Ember['default'].Component.extend( ZfAnimationMixin['default'], {
    classNames: ['action-sheet'],
    classNameBindings: ['position'],
    position: 'bottom',

    initClasses: ['is-active-add', 'is-active-remove'],
    transitionClasses: ['is-active-add-active', 'is-active-remove-active'],

    animationSpeed: 'slow',

    animationIn: (function() {
      var className;
      switch (this.get('position')) {
        case 'top':
          className = 'slideInDown';
        break;

        case 'bottom':
          className = 'slideInUp';
        break;

        case 'left':
          className = 'slideInLeft';
        break;

        case 'right':
          className = 'slideInRight';
        break;
      }
      return className;
    }).property('position'),

    animationOut: (function() {
      var className;
      switch (this.get('position')) {
        case 'top':
          className = 'slideOutUp';
        break;

        case 'bottom':
          className = 'slideOutDown';
        break;

        case 'left':
          className = 'slideOutRight';
        break;

        case 'right':
          className = 'slideOutLeft';
        break;
      }
      return className;
    }).property('position'),
  });

  exports['default'] = ZfActionSheetComponent;

});