define('ember-foundation-apps/components/zf-button', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  var ZfButton = Ember['default'].Component.extend({
    classNames: ['action-button'],
    tagName: 'button',

    action: 'toggle',
    targetId: false,
    targetType: false,
    targetElement: null,

    click: function() {
      var v;
      if ( this.get('targetElement') === null ) {
        var id = this.get('targetId');
        if ( ! id ) { return false; }

        if ( Ember['default'].View.views.hasOwnProperty(id) ) {
          v = Ember['default'].View.views[id];
          this.set('targetElement', v);
        }
      } else {
        v = this.get('targetElement');
      }
      switch (this.get('action')) {
        case 'toggle':
          v.toggle();
        break;

        case 'open':
          v.enter();
        break;

        case 'close':
          v.leave();
        break;
      }
      return false;
    }
  });

  exports['default'] = ZfButton;

});