define('ember-foundation-apps/components/zf-modal', ['exports', 'ember', 'ember-foundation-apps/mixins/zf-animation'], function (exports, Ember, ZfAnimationMixin) {

  'use strict';

  var ZfModalComponent = Ember['default'].Component.extend( ZfAnimationMixin['default'], {
    classNameBindings: ['calculatedClass'],

    calculatedClass: (function() {
      if ( this.get('isOverlay') ) {
        return 'modal-overlay';
      } else {
        return 'modal';
      }
    }).property('isOverlay'),

    animationIn: 'fadeIn',
    animationOut: 'fadeOut',

    isOverlay: true,

    enter: function() {
      this._super();
      this.get('childViews').forEach(function(item){
        item.enter();
      });
    },
    leave: function() {
      this._super();
      this.get('childViews').forEach(function(item){
        item.leave();
      });
    }
  });

  exports['default'] = ZfModalComponent;

});