define('ember-foundation-apps/components/zf-notification', ['exports', 'ember', 'ember-foundation-apps/mixins/zf-animation'], function (exports, Ember, ZfAnimationMixin) {

  'use strict';

  var ZfNotificationComponent = Ember['default'].Component.extend( ZfAnimationMixin['default'], {
    classNameBindings: ['typeClass', 'position'],

    type: 'static',
    isDynamic: Ember['default'].computed.equal('type', 'dynamic'),
    typeClass: (function() {
      var className;
      switch (this.get('type')) {
        case 'static':
          className = 'static-notification';
        break;

        case 'dynamic':
          className = 'notification-container';
        break;

        case 'child':
          className = 'notification';
        break;
      }

      return className;
    }).property('type'),

    title: "",
    image: false,
    position: 'top-right',
    notifications: Ember['default'].ArrayProxy.create(),
  });

  exports['default'] = ZfNotificationComponent;

});